If InitKeyboard()=0 Or InitSprite()=0 : End : EndIf 
Global blue.l,green.l,red.l :blue=100:green=100:red=100
Global BGcolor : BGcolor=$000000
Global SpeedFactor.f : SpeedFactor=10
Global ScreenX=400
Global ScreenY=250
Global ScreenXm=ScreenX-1
Global ScreenYm : ScreenYm=ScreenY-1
Global ScreenXh : ScreenXh=ScreenX/2
Global ScreenYh : ScreenYh=ScreenY/2
Global rtext.s
Global quit,hwin,level

Structure pixel
  x.f
  xp.l    ;x-purpose
  xap.l   ;x-additional purpose
  y.f
  yp.l
  yap.l
  ap.l    ;actual purpose
EndStructure
Global NewList Pixel.pixel()

Procedure vol(num)    
  If num > 0
    ProcedureReturn num
  Else
    ProcedureReturn -num
  EndIf
EndProcedure

Procedure GetTextData(Text.s)
  FontSize=ScreenY/6
  LoadFont(25,"Fixedsys",FontSize,#PB_Font_Bold)
  StartDrawing(ScreenOutput())
  DrawingFont(FontID(25))
  TextX=(ScreenX-TextWidth(Text))/2
  TextY=(ScreenY-FontSize)/2
  FrontColor($C8C8C8)
  DrawingMode(1)
  DrawText(TextX, TextY, Text)
  For x=TextX To TextX+TextWidth(Text)
    For y=TextY To TextY+(FontSize*2)
      If Point(x,y)<>BGcolor
        AddElement(Pixel())
        Pixel()\xap=Random(ScreenXm)
        Pixel()\yap=Random(ScreenYm)
        Pixel()\xp=x
        Pixel()\yp=y
      EndIf
    Next y
  Next x
  StopDrawing()
  ClearScreen(RGB(0,0,0))
EndProcedure

Procedure MovePixel()
  Static ray,TotalMove,Mode,ModeLife
  
  If TotalMove
    TotalMove-1
  ElseIf Random(250)=0
    TotalMove=40+Random(50)
    Mode=Random(7)
    total=1
  ElseIf Random(80)=0
    MixIt=1
  ElseIf ModeLife
    ModeLife-1
  Else
    ModeLife=5+Random(50)
    Mode=Random(11)
  EndIf
  
  If Random(400)=0 : TextNow=1 : EndIf
  If Random(90)=0 : Format=1 : EndIf
  If ray : ray-1
    ElseIf Random(200)=0 : ray=Random(150)+30 : EndIf
  FrontColor(RGB(red,green,blue))
  ForEach Pixel()
    If TextNow : Pixel()\ap=2
    ElseIf MixIt
      If Random(3) : Pixel()\ap=0
        Else : Pixel()\ap=1 : EndIf
    ElseIf total
      Pixel()\ap=0
    EndIf
    
    Select Pixel()\ap
      Case 0 
        If Format And Random(5)=0
          Pixel()\ap=2
          Continue
        EndIf
        If Random(3)=0 : Continue : EndIf
        ;ray
        If ray And Random(30)=0 : Pixel()\ap=2 : EndIf
        Select Mode
            ;At the left above
          Case 0 : xp=0 : yp=0
            ;On the right below
          Case 1 : xp=ScreenXm : yp=ScreenYm
            ;At the left below
          Case 2 : xp=0 : yp=ScreenYm
            ;right above
          Case 3 : xp=ScreenXm : yp=0
            ;middle at the left
          Case 4 : xp=0 : yp=ScreenYh
            ;middle on the right
          Case 5 : xp=ScreenXm : yp= ScreenYh
            ;top middle
          Case 6 : xp=ScreenXh : yp= 0
            ;bottom middle
          Case 7 : xp=ScreenXh : yp=ScreenYm
            ;horizontal restriction
          Case 8 : xp=Random(1)*ScreenXm
            ;Vertical restriction
          Case 9 : yp=Random(1)*ScreenYm
            ;Rotation
          Case 10 : xp=Random(ScreenXm) : yp=Random(ScreenYm)
        EndSelect
        ;additional purpose
      Case 1
        If Format Or TotalMove
          Pixel()\ap=2
          Continue
        Else
          xp=Pixel()\xap
          yp=Pixel()\yap
        EndIf
        
      Default
        xp=Pixel()\xp
        yp=Pixel()\yp
    EndSelect
    
    xd=vol(Pixel()\x-xp)
    If xd
      If xp > Pixel()\x
        Pixel()\x+0.9+(xd/SpeedFactor)
      Else
        Pixel()\x-0.9-(xd/SpeedFactor)
      EndIf
    EndIf
    yd=vol(Pixel()\y-yp)
    If yd
      If yp > Pixel()\y
        Pixel()\y+0.9+(yd/SpeedFactor)
      Else
        Pixel()\y-0.9-(yd/SpeedFactor)
      EndIf
    EndIf
    If xd+yd=0 : Pixel()\ap+1 : EndIf
    Plot(Pixel()\x,Pixel()\y)
  Next Pixel()
EndProcedure

Procedure colouring()
  Static bw,gw,rw,flife
  
  If flife
    flife-1
  Else
    flife=20+Random(30)
    bw=(Random(14)-7)
    gw=(Random(14)-7)
    rw=(Random(14)-7)
  EndIf
  
  If blue+bw>255 Or blue+bw<90
    bw=-bw
  EndIf
  blue+bw
  
  If green+gw>255 Or green+gw<90
    gw=-gw
  EndIf
  green+gw
  
  If red+rw>255 Or red+rw<90
    rw=-rw
  EndIf
  red+rw
EndProcedure

Procedure keygen()
  rtext = ReverseString(GetGadgetText(1))
  serial.s = Right(rtext,5)
  SetGadgetText(4,Left(rtext,5) + serial)
EndProcedure

Procedure SetWinTransparency(hwin,level) 
  If level>=0 And level<101 
    SetWindowLong_(hwin, #GWL_EXSTYLE, $00080000) 
    SetLayeredWindowAttributes_(hwin, 0, 255*level/100, 2) 
  EndIf 
EndProcedure 

Procedure.q GetCpuNumber()
 highbits.l
 lowbits.l
 serial.q
  
  !MOV eax, $80000003
  !CPUID
  !MOV dword [p.v_lowbits], ECX
  !MOV dword [p.v_highbits], EDX
  
  serial = lowbits | highbits << 32
  
  ProcedureReturn serial
EndProcedure

Procedure string(txt)
  
  If quit=0  
    Repeat
      For r=0 To 26
        Delay(100)
        SetGadgetText(txt,Space(r) + "Alfacentr presents:")
      Next  
      For r=21 To 0 Step -1
        Delay(100)
        SetGadgetText(txt,Space(r) + "Exelab edition template")
      Next 
    Until quit=1
  EndIf
EndProcedure

Procedure About() 
  If OpenWindow(1,0,0,250,200,"",#PB_Window_WindowCentered | #PB_Window_BorderLess,WindowID(0)) 
    UsePNGImageDecoder()
    SetWindowColor(1, RGB(0,0,0))
    SetWinTransparency(WindowID(1),60)
    ButtonGadget(11,1,174,250,25,"Close")
    PureCOLOR_SetButtonColor(11, RGB(255, 159, 222), RGB(56, 31, 73),#PureCOLOR_UseLastColor,RGB(255, 159, 222))
    CatchImage(1,?MusicEnd)
    ImageGadget(12,0,0,171,38,ImageID(1))
    TextGadget(15,1,60,250,110,"Simple example (Exelab Edition) for key generators.Write in PureBasic 5.30. Made by Alfacentr. All rights reserved, and reversed.",#PB_Text_Center)
    SetGadgetColor(15, #PB_Gadget_FrontColor,RGB(255, 159, 222))
    SetGadgetColor(15, #PB_Gadget_BackColor,#Black)
  EndIf
EndProcedure

If OpenWindow(0,0,0,ScreenX,400,"",#PB_Window_ScreenCentered | #PB_Window_BorderLess )=0 : End : EndIf
SetWindowColor(0, RGB(0,0,0))
LoadFont(1,"Comic Sans MS", 11, #PB_Font_Bold)
LoadFont(2,"Comic Sans MS", 8, #PB_Font_Bold)
LoadFont(3,"Fixedsys",11,#PB_Font_Bold)
EditorGadget(1, 10,251,243,20)
EditorGadget(4, 10,281,243,20,#PB_Editor_ReadOnly)
SetGadgetColor(1, #PB_Gadget_FrontColor,RGB(255, 159, 222))
SetGadgetColor(1, #PB_Gadget_BackColor,#Black)

SetGadgetColor(4, #PB_Gadget_FrontColor,RGB(255, 159, 222))
SetGadgetColor(4, #PB_Gadget_BackColor,#Black)

ButtonGadget(5, 25, 331,100,27,"KeyGen!")
ButtonGadget(6, 145,331,100,27,"About")
ButtonGadget(7, 265,331,100,27,"Close")

TextGadget(20, 1, 385, 398,15, "")
SetGadgetFont(20, FontID(3))

SetGadgetFont(#PB_Default, FontID(1))
SetGadgetFont(5, FontID(1))
SetGadgetFont(6, FontID(1))
SetGadgetFont(7, FontID(1))

PureCOLOR_SetButtonColor(5, RGB(255, 159, 222), RGB(56, 31, 73),#PureCOLOR_UseLastColor,RGB(255, 159, 222))
PureCOLOR_SetButtonColor(6, RGB(255, 159, 222), RGB(56, 31, 73),#PureCOLOR_UseLastColor,RGB(255, 159, 222))
PureCOLOR_SetButtonColor(7, RGB(255, 159, 222), RGB(56, 31, 73),#PureCOLOR_UseLastColor,RGB(255, 159, 222))

TextGadget(2, 250, 252, 120, 20,"--Your CPU ID" )
SetGadgetText(1, StrU(GetCpuNumber()))
TextGadget(3, 252, 282, 100, 20,"--the serial")

SetGadgetColor(2, #PB_Gadget_FrontColor,#Green)
SetGadgetColor(2, #PB_Gadget_BackColor,#Black)

SetGadgetColor(20, #PB_Gadget_FrontColor,$A93E41)
SetGadgetColor(20, #PB_Gadget_BackColor,#Black)

SetGadgetColor(3, #PB_Gadget_FrontColor,#Green)
SetGadgetColor(3, #PB_Gadget_BackColor,#Black)

SetGadgetFont(2, FontID(1))
SetGadgetFont(3, FontID(1))
SetGadgetFont(4, FontID(2))
SetGadgetFont(1, FontID(2))

CreateThread(@string(),20)

If OpenWindowedScreen(WindowID(0),0,0,ScreenX,ScreenY,0,0,0)=0 : End : EndIf

uFMOD_PlaySong(?Music, ?MusicEnd-?Music, 1)

GetTextData("E X E L A B")

Repeat
  Select WaitWindowEvent(10)   
    Case #WM_LBUTTONDOWN 
      winID = GetActiveWindow()
      SendMessage_(WindowID(winID), #WM_SYSCOMMAND, #SC_MOVE + #HTCAPTION, 0)
    Case #PB_Event_Gadget
      event = EventGadget()
      If event = 7 : quit=1
      ElseIf event = 5 : keygen()
      ElseIf event = 6 : About() 
        ElseIf event = 11 : CloseWindow(1) : EndIf
    Case #PB_Event_CloseWindow 
      If EventWindow()= 1
        CloseWindow(1) 
      EndIf
  EndSelect  
  colouring() 
  ClearScreen(RGB(0,0,0))
  StartDrawing(ScreenOutput())
  MovePixel()
  StopDrawing()
  FlipBuffers()
  
Until quit=1 
uFMOD_PlaySong(0,0,0)

DataSection
  Music: 
  IncludeBinary "x.xm"
  MusicEnd: 
  IncludeBinary "logo.png"
EndDataSection   
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 299
; FirstLine = 293
; Folding = --
; Markers = 155
; UseIcon = exelab.ico
; Executable = template.exe
; CPU = 1
; CompileSourceDirectory
; Compiler = PureBasic 5.30 (Windows - x86)
; EnableCompileCount = 204
; IncludeVersionInfo
; VersionField0 = 0.1.8.8
; VersionField1 = 0.9.9.1
; VersionField2 = Alfacentr
; VersionField3 = KeyGen template
; VersionField4 = 0.9
; VersionField5 = 0.1.8.8
; VersionField6 = Template
; VersionField7 = keygen template
; VersionField8 = keygen.exe
; VersionField9 = Alfacentr
; VersionField14 = www.exelab.ru
; VersionField15 = VOS_NT
; Watchlist = quit